
import java.io.IOException;

import org.jboss.identity.idm.impl.configuration.jaxb2.generated.RepositoriesType;
import org.jbpm.api.ExecutionService;
import org.jbpm.api.NewDeployment;
import org.jbpm.api.ProcessDefinition;
import org.jbpm.api.ProcessDefinitionQuery;
import org.jbpm.api.ProcessEngine;
import org.jbpm.api.RepositoryService;
import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationContext;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

@ContextConfiguration
@RunWith(SpringJUnit4ClassRunner.class)
public class SimpleTest {

	@Autowired
	private ProcessEngine processEngine;

	@Autowired
	private ApplicationContext applicationContext;

	private static String deployementId = null;

	@Before
	public void deployProcess() throws IOException {
		RepositoryService repositoryService = processEngine.getRepositoryService();
		if (deployementId == null) {
			NewDeployment deployment = repositoryService.createDeployment();
			deployment.addResourceFromInputStream("simplejpdl", applicationContext.getResource(
					"classpath:/simple.jpdl.xml").getInputStream());
			deployementId = deployment.deploy();
			System.out.println("deploymentId : " + deployementId);
			ProcessDefinitionQuery query = repositoryService.createProcessDefinitionQuery();
			
			for(ProcessDefinition definition : query.notSuspended().list()){
				System.out.println("definition id : " + definition.getId());
				System.out.println("definition key : " + definition.getKey());
				System.out.println("definition name : " + definition.getName());
			}
		}
		System.out.println("deploymentId : " + deployementId);
	}

	private ExecutionService getExecutionService() {
		return processEngine.getExecutionService();
	}

	@Test
	public void testInstanciateByKey() {
		getExecutionService().startProcessInstanceByKey("simple");

	}

	@Test
	public void testInstanciateByID() {
		getExecutionService().startProcessInstanceById("SuperSimple");
	}

}
